freeslot("SPR_NADA", "sfx_nosfx")

if not srb2p return end

charStats["abacaxonic"] = {

		-- GENERAL

		name = "Abacaxonic",			-- This is only for bots / enemies
		basehp = 40,			-- base HP for level 1
		basesp = 70,
		persona = "abacaxonic",
		persona_pvp = "abacaxonic",
		melee_natk = "sonic_atk1",	-- normal melee attack

		atk = 30,
		acc = 90,
		crit = 1,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
		anim_stand_bored =	{SPR_PLAY, A, 1, "SPR2_STND"},	-- standing (rare anim)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_STND"},		-- guarding
		anim_move =			{SPR_PLAY, A, 1, "SPR2_STND"},		-- moving
		anim_run =			{SPR_PLAY, A, 1, "SPR2_STND"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 1, "SPR2_STND"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 1, "SPR2_STND"},	-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_DEAD"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_DEAD"},		-- knocked down from weakness / crit
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_STND"},		-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_STND"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},		-- dies
		anim_revive =		{SPR_PLAY, A, 1, "SPR2_STND"},		-- gets revived
		anim_evoker =		{SPR_PLAY, A, 2, "SPR2_STND"},	-- uses evoker

		anim_special1 =		{SPR_PLAY, A, 2, "SPR2_STND"},
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_STND"},

		vfx_summon = {"sfx_nosfx"},
        vfx_skill = { "sfx_nosfx"},
        vfx_item = {"sfx_nosfx"},
        vfx_hurt = {"sfx_nosfx"},
        vfx_hurtx = {"sfx_nosfx"},
        vfx_die = {"sfx_nosfx"},
        vfx_heal = {"sfx_nosfx"},
        vfx_healself = {"sfx_nosfx"},
        vfx_kill = {"sfx_nosfx"},
        vfx_1more = {"sfx_nosfx"},
        vfx_crit = {"sfx_nosfx"},
        vfx_aoaask = {"sfx_nosfx"},
        vfx_aoado = {"sfx_nosfx"},
        vfx_aoarelent = {"sfx_nosfx"},
        vfx_miss = {"sfx_nosfx"},
        vfx_dodge = {"sfx_nosfx"},
        vfx_win = {"sfx_nosfx"},
        vfx_levelup = {"sfx_nosfx"},

						
						vfx_tartarus_pit = {"sfx_pscree"},
						vfx_tartarus_item = {"sfx_ncitem"},
						vfx_tartarus_spring = {"sfx_nxdone"},
						vfx_tartarus_spikepit = {"sfx_beeyow"},


		icon = "ICO_ABX",	-- icon for net select and other menus
		hudbust = "ABX_A",			-- patch to draw on the stat hud
		hudbustlayer = "",		-- transparent patch to draw for status conditions
		hudaoa = "H_ABXAOA",	-- patch for all out attack hud
		aoa_quote = "Voce nao vera a \nluz do dia.",
		hudcutin = "ABXX_A",	-- cut in
		hudspr = "ABXX",	-- sprite prefix since hud can't retrieve it. yikes

		tip = "Aquele que eternamente jaz nao se encontra verdadeiramente morto. E em eras incomuns, ate a morte pode morrer. Essa criatura possui poderes psiquicos e ataques fisicos, mas nao importa onde ele esteja, ele sabe onde voce dorme.",

}

personaList["abacaxonic"] = {
		-- GENERAL
		name = "Abacaxonic",
		arcana = nil,
		sprite = nil,
		startframe = nil,
		anim_idle = nil,
		anim_atk = 	nil,

		-- STATS (at level 10. so we can have some precision, y'see)

		strength = 9,
		magic = 12,
		endurance = 6,
		luck = 5,
		agility = 8,
		weak = ATK_FIRE|ATK_SLASH,
		resist = ATK_CURSE,
		drain = ATK_PSY,

		skills = {
			{"psi", 1}, {"cleave", 1}, {"dia", 4}, {"mapsi", 7},
			{"invigorate 1", 13}, {"giant slice", 17},
			{"psio", 19},  {"diarama", 21, "dia"},

			{"mapsio", 24, "mapsi"}, {"masukunda", 28},
			{"invigorate 2", 32, "invigorate 1"},
			{"blade of fury", 41, "giant slice"},
			{"mind charge", 46}, {"diarahan", 51, "diarama"},
			{"fatal end", 49, "blade of fury"},
			{"mapsiodyne", 54, "psio"}, {"fazer nada", 57, "mapsio"},
			{"diploma de palhaco", 65, "mind charge"},
			{"psycho force", 61},
		},
}

attackDefs["diploma de palhaco"] = {
		name = "Diploma de Palhaco",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 1,
		desc = "Com o poder do diploma de palhaco, /nsuas habilidades dao mais x2.5 de dano.",
		target = TGT_CASTER,
		superbuff = true,
		powercharge = true,				-- do not remove power charge status after using this skill.
		mindcharge = true,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 1
				playSound(mo.battlen, sfx_rejekt)
			end
			if timer == 20
				playSound(mo.battlen, sfx_buff2)
				target.powercharge = true
				target.mindcharge = true
				BTL_logMessage(targets[1].battlen, target.name.." se torna um palhaco de verdade.")
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_RED
					dust.scale = FRACUNIT*2
				end
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_EMERALD
					dust.scale = FRACUNIT*2
				end
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_YELLOW
					dust.scale = FRACUNIT*2
				end

			elseif timer > 20 and timer <= 50

				if leveltime%2 == 0
					for i = 1,16

						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_RED
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
						
						thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_EMERALD
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
						
						thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_YELLOW
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end

				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_RED
					thok.tics = P_RandomRange(10, 35)
					
					thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_EMERALD
					thok.tics = P_RandomRange(10, 35)
					
					thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_YELLOW
					thok.tics = P_RandomRange(10, 35)
				end
			elseif timer == 60
				return true
			end
		end,
}
attackDefs["fazer nada"] = {
		name = "Fazer Nada",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Aumenta 1 nivel de magia fazendo /nabsolutamente nada.",
		target = TGT_ALLALLIES,
		buff = true,	-- is a buff
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

				local target = targets[i]

				if timer == 20 + (i-1)*16
					playSound(mo.battlen, sfx_buff)
					buffStat(target, "mag")
					
					BTL_logMessage(targets[1].battlen, "Magia aumentada!")
					
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_ORANGE
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*16 and timer <= 50 + (i-1)*16

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_ORANGE
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_ORANGE
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 60 + (#targets-1)*16
				return true
			end
		end,
}

DNG_Abilities["abacaxonic"] = {

	jfunc = 	function(p)
					local mo = p.mo

					p.drawangle = mo.angle
					local thokspeed = FixedHypot(mo.momx, mo.momy) > 20*mo.scale and FixedHypot(mo.momx, mo.momy) or 20*mo.scale
					P_InstaThrust(mo, p.mo.angle, thokspeed)
					P_SetObjectMomZ(mo, FRACUNIT*8)

					local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
					t.color = mo.color
					S_StartSound(mo, sfx_thok)
				end,

	func =		function(p)
					local mo = p.mo

					if mo.p_abl
						if ((mo.eflags & MFE_VERTICALFLIP) and mo.momz < 0)
						or (not (mo.eflags & MFE_VERTICALFLIP) and mo.momz > 0)
							if (leveltime%2)
								local g = P_SpawnGhostMobj(mo)
								g.tics = 4
								g.colorized = true
							end
						else
							mo.state = S_PLAY_FALL
							p.pflags = $ & ~PF_JUMPED
							mo.p_abl = false
						end
					end
				end,
}
